/*:
# **Kapitel 4.8**
## Einstieg
*/

/**
Erlaubt das vollständige Anlegen im Konstruktor.
 
- author: Albert Wiedemann
- version: 1.0
 */
class RechteckBesser: Rechteck
{
    /**
    Legt das Rechteck nach den gegebenen Daten an.
	- parameters:
        - x: x-Position der linken oberen Ecke
        - y: y-Position der linken oberen Ecke
        - breite: Breite des Rechtecks
        - höhe: Höhe des Rechtecks
        - farbe: Farbe des Rechtecks
    */
    init (x: Int, y: Int, breite: Int, höhe: Int, farbe: String)
    {
        super.init();
        PositionSetzen(x: x, y: y)
        GrößeSetzen(breite: breite, höhe: höhe)
        FarbeSetzen(farbe: farbe)
    }
}

/**
Erlaubt das vollständige Anlegen im Konstruktor.
 
- author: Albert Wiedemann
- version: 1.0
 */
class KreisBesser: Kreis
{
    /**
    Legt den Kreis nach den gegebenen Daten an.
	- parameters:
        - x: x-Position des Mittelpunkts
        - y: y-Position des Mittelpunkts
        - radius: Radius des Kreises
        - farbe: Farbe des Kreises
    */
    init (x: Int, y: Int, radius: Int, farbe: String)
    {
        super.init();
        PositionSetzen(x: x, y: y)
        RadiusSetzen(radius: radius)
        FarbeSetzen(farbe: farbe)
    }
}

/**
Erlaubt das vollständige Anlegen im Konstruktor.
 
- author: Albert Wiedemann
- version: 1.0
 */
class DreieckBesser: Dreieck
{
//#-editable-code
    /**
    Legt das Dreieck nach den gegebenen Daten an.
	- parameters:
        - x: x-Position der Spitze
        - y: y-Position der Spitze
        - breite: Breite des Dreiecks
        - höhe: Höhe des Dreiecks
        - farbe: Farbe des Dreiecks
    */
    init (x: Int, y: Int, breite: Int, höhe: Int, farbe: String)
    {
        super.init();
        PositionSetzen(x: x, y: y)
        GrößeSetzen(breite: breite, höhe: höhe)
        FarbeSetzen(farbe: farbe)
    }
//#-end-editable-code
}
/*:
Bei vielen der bisherigen Beispiele wie Krümel und Monster oder Regentropfen musstest du eine ganze
Reihe von Hilfsobjekten anlegen, um eine passende Testsituation herzustellen.\
a\
Erkunde, wie im Projekt SzenariumAufbauen in der Klasse AUFBAU die Objekte angelegt werden.\
b\
Vergleiche das durch das Projekt erzeugte Bild mit dem Bild rechts. Ergänze das Projekt so,
dass das rote Dreieck wie rechts abgebildet gezeichnet wird.*/
/**
Baut im Konstruktor das Szenarium auf

- author: Albert Wiedemann
- version: 1.0
*/
class Aufbau
{

    /**
    Legt die benötigten Objekte an.
    */
    init ()
    {
//#-editable-code
        KreisBesser(x: 150, y: 150, radius: 50, farbe: "rot")
        DreieckBesser(x: 200, y: 50, breite: 60, höhe: 50, farbe: "grün")
        RechteckBesser(x: 100, y: 220, breite: 200, höhe: 50, farbe: "grün")
        RechteckBesser(x: 270, y: 60, breite: 130, höhe: 70, farbe: "blau")
        DreieckBesser(x: 350, y: 190, breite: 70, höhe: 80, farbe: "rot")
//#-end-editable-code
    }
}
/*:
c\
Erkunde, wie in der Klasse AUFBAU2 erreicht wird, dass die Objekte zufällig Positionen einnehmen.
Ergänze die Klasse so, dass auch die Größen der Objekte zufällig festgelegt werden.*/
/**
Baut im Konstruktor das Szenarium auf

- author: Albert Wiedemann
- version: 1.0
*/
class Aufbau2
{
    /** der Zufallsgenerator */
    var zufall: Zufall
    
    /**
    Legt die benötigten Objekte an.
    */
    init ()
    {
//#-editable-code
        zufall = Zufall()
        RechteckBesser(x: zufall.ZufallGanz(top: 400), y: zufall.ZufallGanz(top: 200), breite: 200, höhe: 50, farbe: "grün");
        RechteckBesser(x: zufall.ZufallGanz(top: 400), y: zufall.ZufallGanz(top: 200), breite: 130, höhe: 70, farbe: "blau");
        DreieckBesser(x: zufall.ZufallGanz(top: 400) + 50, y: zufall.ZufallGanz(top: 200), breite: 60, höhe: 50, farbe: "grün");
        DreieckBesser(x: zufall.ZufallGanz(top: 400) + 50, y: zufall.ZufallGanz(top: 200), breite: 70, höhe: 80, farbe: "rot");
        KreisBesser(x: zufall.ZufallGanz(top: 400) + 50, y: zufall.ZufallGanz(top: 150) + 50, radius: 50, farbe: "rot");
//#-end-editable-code
    }
}


//#-editable-code
//Aufbau()
Aufbau2()
//#-end-editable-code
