/*:
# **Kapitel 4.8**
## Aufgabe 5 Krümel und Monster (Teil 6)
*/
/**
Verwaltet das Monster

- author: Albert Wiedemann
- version: 1.0
 */
class Monster: Figur
{
//#-editable-code
    /** Anzahl der gefressenen Krümel */
    var anzahl: Int
    /** Mundstellung */
    var mundIstZu: Bool
    
    /**
     * Legt die Figur und die Munstellung fest.
     */
    override init()
    {
        anzahl = 0
        mundIstZu = true
        super.init()
        Schließen(farbe: "gelb")
        GesamtFenster.KnopfbuchstabenSetzen(nr: 0, c: " ")
    }

    /**
    Stellt das gelb gefärbte Monster mit geschlossenem Mund dar.
    */
    func GeschlossenGelb()
    {
        EigeneFigurLöschen()
        FigurteilFestlegenEllipse(x: -50, y: -50, breite: 100, höhe: 100, farbe: "gelb")
        FigurteilFestlegenRechteck(x: 0, y: -2, breite: 50, höhe: 4, farbe: "schwarz")
        FigurteilFestlegenEllipse(x: 10, y: -40, breite: 20, höhe: 20, farbe: "schwarz")
    }

    /**
    Stellt das orange gefärbte Monster mit geschlossenem Mund dar.
    */
    func GeschlossenOrange()
    {
        EigeneFigurLöschen()
        FigurteilFestlegenEllipse(x: -50, y: -50, breite: 100, höhe: 100, farbe: "orange")
        FigurteilFestlegenRechteck(x: 0, y: -2, breite: 50, höhe: 4, farbe: "schwarz")
        FigurteilFestlegenEllipse(x: 10, y: -40, breite: 20, höhe: 20, farbe: "schwarz")
    }

    /**
    Stellt das rot gefärbte Monster mit geschlossenem Mund dar.
    */
    func GeschlossenRot()
    {
        EigeneFigurLöschen()
        FigurteilFestlegenEllipse(x: -50, y: -50, breite: 100, höhe: 100, farbe: "rot")
        FigurteilFestlegenRechteck(x: 0, y: -2, breite: 50, höhe: 4, farbe: "schwarz")
        FigurteilFestlegenEllipse(x: 10, y: -40, breite: 20, höhe: 20, farbe: "schwarz")
    }

    /**
    Stellt das grün gefärbte Monster mit geschlossenem Mund dar.
    */
    func GeschlossenGrün()
    {
        EigeneFigurLöschen()
        FigurteilFestlegenEllipse(x: -50, y: -50, breite: 100, höhe: 100, farbe: "grün")
        FigurteilFestlegenRechteck(x: 0, y: -2, breite: 50, höhe: 4, farbe: "schwarz")
        FigurteilFestlegenEllipse(x: 10, y: -40, breite: 20, höhe: 20, farbe: "schwarz")
    }

    /**
    Stellt das Monster in der angegebenen Farbe mit offenem Mund dar.
    - parameters:
    	- farbe: die gewünschte Farbe
    */
    func Offen(farbe: String)
    {
        EigeneFigurLöschen()
        FigurteilFestlegenEllipse(x: -50, y: -50, breite: 100, höhe: 100, farbe: farbe)
        FigurteilFestlegenDreieck(x1: 0, y1: 0, x2: 50, y2: -10, x3: 50, y3: 10, farbe: "schwarz")
        FigurteilFestlegenEllipse(x: 10, y: -40, breite: 20, höhe: 20, farbe: "schwarz")
    }

    /**
    Stellt das in einer der Farben gelb, orange, rot bzw. grün mit geschlossenem Mund dar.
	- parameters:
    	- farbe: die gewünschte Farbe
     */
    func Schließen(farbe: String)
    {
        if farbe == "gelb"
        {
            GeschlossenGelb()
        }
        if farbe == "orange"
        {
            GeschlossenOrange()
        }
        if farbe == "rot"
        {
            GeschlossenRot()
        }
        if farbe == "grün"
        {
            GeschlossenGrün()
        }
    }

    /**
    Stellt das in einer der Farben gelb, orange, rot bzw. grün mit offenem Mund dar.
	- parameters:
    	- farbe: die gewünschte Farbe
    */
    func Öffnen(farbe: String)
    {
        if (farbe == "gelb") || (farbe == "orange") || (farbe == "rot") || (farbe == "grün")
        {
            Offen(farbe: farbe)
        }
    }

    /**
    Die Aktionsmethode für gedrückte Sondertasten.
	- parameters:
        - taste: KeyCode der gedrückten Taste
     */
    override func SonderTasteGedrückt (taste: Int)
    {
        switch taste
        {
            case 123:
                Drehen(grad: 90)
            case 126:
                Gehen(länge: 10)
            case 124:
                Drehen(grad: -90)
            case 125:
                Drehen(grad: 180)
            default:
                break
        }
    }

    /**
    Die Aktionsmethode für gedrückte Tasten.
	- parameters:
        - taste: die gedrückte Taste
    */
   override func TasteGedrückt (taste: Character)
    {
        switch taste
        {
        case " ":
            Gehen(länge: 50)
        default:
            break
        }
    }

    /**
    Das Monster geht maximal bis zum Rand
     */
    override func AktionAusführen()
    {
        if mundIstZu
        {
            Öffnen(farbe: "gelb")
            mundIstZu = false
        }
        else
        {
            Schließen(farbe: "gelb")
            mundIstZu = true;
        }
        if WinkelGeben() == 0
        {
            if XPositionGeben() < 740
            {
                Gehen(länge: 10)
            }
            else
            {
                Verloren()
            }
        }
        else
        {
            if WinkelGeben() == 90
            {
                if YPositionGeben() > 30
                {
                    Gehen(länge: 10)
                }
                else
                {
                    Verloren()
                }
            }
            else
            {
                if WinkelGeben() == 180
                {
                    if XPositionGeben() > 10
                    {
                        Gehen(länge: 10)
                    }
                    else
                    {
                        Verloren()
                    }
                }
                else
                {
                    if WinkelGeben() == 270
                    {
                        if YPositionGeben() < 590
                        {
                            Gehen(länge: 10)
                        }
                        else
                        {
                            Verloren()
                        }
                    }
                }
            }
        }
        if Berührt(farbe: "orange")
        {
            anzahl = anzahl + 1
        }
        if anzahl == 10
        {
            Gewonnen()
        }
    }
//#-end-editable-code
}

/**
Verwaltet einen Krümel

- author: Albert Wiedemann
- version: 1.0
 */
class Krümel: Figur
{
    /**
    Legt Position und Figur fest
	- parameters:
        - x: x-Position des Krümels
        - y: y-Position des Krümels
    */
    init(x: Int, y: Int)
    {
        super.init()
        FigurFestlegen()
        PositionSetzen(x: x, y: y)
    }

    /**
    Stellt den orangen Krümel dar.
    */
    func FigurFestlegen()
    {
        EigeneFigurLöschen()
        FigurteilFestlegenEllipse(x: -5, y: -5, breite: 10, höhe: 10, farbe: "orange")
    }
    
    /**
    Der Krümel verschwindet bei Berührung
    */
    override func AktionAusführen()
    {
        if Berührt()
        {
            Entfernen()
        }
    }
}

/**
Sellt den Gewinntext dar

- author: Albert Wiedemann
- version: 1.0
*/
class Gewonnen: Text
{

    /**
    Legt Position und Text fest
    */
    override init ()
    {
        super.init()
        TextSetzen(text: "Du hast das Spiel gewonnen")
        PositionSetzen(x: 10, y: 20)
    }
}

/**
Sellt den Verlusttext dar

- author: Albert Wiedemann
- version: 1.0
*/
class Verloren: Text
{

    /**
    Legt Position und Text fest
    */
    override init ()
    {
        super.init()
        TextSetzen(text: "Du hast verloren")
        PositionSetzen(x: 700, y: 20)
    }
}

/**
Verstreut die Krümel

- author: Albert Wiedemann
- version: 1.0
 */
class AlleKrümel
{

    /**
    Erzeugt die Krümel
    */
    init ()
    {
        Krümel(x: 600, y: 50)
        Krümel(x: 150, y: 200)
        Krümel(x: 400, y: 30)
        Krümel(x: 500, y: 300)
        Krümel(x: 250, y: 140)
        Krümel(x: 180, y: 560)
        Krümel(x: 700, y: 270)
        Krümel(x: 730, y: 420)
        Krümel(x: 110, y: 70)
        Krümel(x: 330, y: 490)
        Krümel(x: 470, y: 120)
    }
}
/*:
a\
Ergänze in deinem Krümel und Monster-Projekt eine Klasse RAHMEN, deren Konstruktor automatisch
40 Krümel mit zufälliger Position sowie die Monster-Figur erzeugt.\
b\
Lasse die Klasse RAHMEN von EREIGNISBEHANDLUNG erben und starte den
Taktgenerator beim Anlegen des Rahmenobjekts.\
c\
Du kannst in der Klasse RAHMEN auch einen richtigen Monster-Parcours aufbauen, indem du graue
Rechtecke als Hindernisse erzeugst und die Krümel gezielt in den freien Plätzen zwischen den
Hindernissen plazierst. Damit die Monsterfigur nicht in ein Hindernis hineinläuft, kannst du sie
automatisch einen Schritt zurückgehen lassen, wenn sie ein Hindernis berührt.*/
//#-editable-code



//#-end-editable-code

//#-editable-code
AlleKrümel()
Monster()
//#-end-editable-code

