/*:
# **Kapitel 4.7**
## Aufgabe 9a Abiturparty (Teil 2)
*/
/*:
Das Technikteam des John-von-Neumann-Gymnasiums Infohausen ist mit den bisherigen
Steuerungen des Laufstegs und der Tanzfläche noch nicht zufrieden. Es soll jetzt auch
möglich sein, die feste Abfolge der Lichter durch eine zufallsgesteuerte Programmierung zu ergänzen.\
a\
Baue die Einstiegsaufgabe zum Laufsteg aus dem vorigen Kapitel so um, dass die jeweils erste
Lampe des Lauflichts eine zufällige Farbe hat.*/
/**
Klasse zur Beschreibung des Catwalks

- author: Klaus Reinold
- version: 1.0
 */
class Catwalk
{
//#-editable-code
    /** Die Leuchten */
    var leuchten: [Rechteck]
    /** Die zur Verfügung stehenden Farben */
    var farben: [String]
    /** Größe einer Leuchte */
    let breite = 40
    /** Anzahl der Leuchten */
    let spaltenanzahl = 10

    /**
    Der Konstruktor des Catwalks legt die Leuchten an
    */
    init()
    {
        leuchten = [Rechteck]()
        farben = Array<String>()
        var farbe: String
        farbe = "blau"
        for spalte in 0 ..< spaltenanzahl
        {
            leuchten.append(Rechteck())
            leuchten[spalte].GrößeSetzen(breite: breite, höhe: breite)
            leuchten[spalte].PositionSetzen(x: 40 + spalte * breite, y: 50)
            if farbe == "blau"
            {
                farbe = "rot"
            }
            else
            {
                farbe = "blau"
            }
            farben.append(farbe)
            FarbeSetzen(spalte: spalte, farbe: farbe)
        }
    }
    
    /**
    Setzt die angegebene Leuchte auf die gewünschte Farbe
	- parameters:
        - spalte: die Spaltennummer der Leuchte
        - farbe: die gewünschte Farbe
     */
    func FarbeSetzen(spalte: Int, farbe: String)
    {
        leuchten[spalte].FarbeSetzen(farbe: farbe)
        farben[spalte] = farbe
    }
    
    /**
    Gibt die Farbe der angegebene Leuchte
	- parameters:
        - spalte: die Spaltennummer der Leuchte
    - returns: die Farbe der gewünschten Leuchte
    */
    func FarbeGeben(spalte: Int) -> String
    {
        return farben[spalte]
    }
    
    /**
    Meldet die Anzahl der Leuchten
    - returns: Leuchtenanzahl
    */
    func SpaltenanzahlGeben() -> Int
    {
        return spaltenanzahl
    }
//#-end-editable-code
}

/**
Steuerung der Leuchten auf dem Dancefloor

- author: Klaus Reinold
- version: 1.0
 */
class CatwalkSteuerung: Figur
{
//#-editable-code
    /** Der Laufsteg */
    var laufsteg: Catwalk
    /** Der Zähler für die Farbensteuerung */
    var zähler: Int

    /**
    Legt den Laufsteg und den Zufallsgenerator an.
    */
    override init()
    {
        zähler = 0
        laufsteg = Catwalk()
        super.init()
        SichtbarkeitSetzen(sichtbar: false)
    }

    /**
    Lässt die Farben eine Spalte weiter laufen
    */
    override func AktionAusführen()
    {
        for spalte in 0 ..< laufsteg.SpaltenanzahlGeben() - 1
        {
            laufsteg.FarbeSetzen(spalte: spalte, farbe: laufsteg.FarbeGeben(spalte: spalte+1))
        }
        laufsteg.FarbeSetzen(spalte: laufsteg.SpaltenanzahlGeben()-1, farbe: NächsteFarbeGeben())
    }

    /**
    Bestimmt die nächste Farbe
    - returns: nächste Farbe
     */
    func NächsteFarbeGeben() -> String
    {
        var farbe: String
        switch zähler
        {
            case 0: farbe = "weiß"
            case 1: farbe = "rot"
            case 2: farbe = "grün"
            case 3: farbe = "blau"
            case 4: farbe = "gelb"
            case 5: farbe = "magenta"
            case 6: farbe = "cyan"
            case 7: farbe = "hellgelb"
            case 8: farbe = "hellgrün"
            case 9: farbe = "orange"
            case 10: farbe = "braun"
            case 11: farbe = "grau"
            default: farbe = "schwarz"
        }
        zähler = (zähler + 1) % 12
        return farbe
    }
//#-end-editable-code
}

//#-editable-code
let c = CatwalkSteuerung()
//#-end-editable-code
