/*:
# **Kapitel 4.7**
## Aufgabe 9b Abiturparty (Teil 2)
*/
/*:
Das Technikteam des John-von-Neumann-Gymnasiums Infohausen ist mit den bisherigen
Steuerungen des Laufstegs und der Tanzfläche noch nicht zufrieden. Es soll jetzt auch
möglich sein, die feste Abfolge der Lichter durch eine zufallsgesteuerte Programmierung zu ergänzen.\
b\
Baue die Aufgabe zur Tanzfläche aus dem vorigen Kapitel so um, dass alle Lampen der Tanzfläche eine zufällige Farbe erhalten. */
/**
Klasse zur Beschreibung des Dancefloors

- author: Klaus Reinold
- version: 1.0
 */
class Dancefloor
{
//#-editable-code
    /** Die Leuchten */
    var leuchten: [[Rechteck]]
    /** Die zur Verfügung stehenden Farben */
    var farben: [[String]]
    /** Größe einer Leuchte */
    let breite = 40
    /** Anzahl der Leuchten pro Spalte */
    let spaltenanzahl = 19
    /** Anzahl der Leuchten pro Zeile */
    let zeilenanzahl = 19

    /**
    Der Konstruktor des Dancefloors legt die Leuchten an
    */
    init()
    {
        leuchten = [[Rechteck]]()
        farben = Array<Array<String>>()
        var farbe: String
        farbe = "blau"
        for spalte in 0 ..< spaltenanzahl
        {
            leuchten.append([Rechteck]())
            farben.append(Array<String>())
            for zeile in 0 ..< zeilenanzahl
            {
                leuchten[spalte].append(Rechteck())
                leuchten[spalte][zeile].GrößeSetzen(breite: breite, höhe: breite)
                leuchten[spalte][zeile].PositionSetzen(x: spalte * breite, y: zeile*breite)
                if farbe == "blau"
                {
                    farbe = "rot"
                }
                else
                {
                    farbe = "blau"
                }
                farben[spalte].append(farbe)
                FarbeSetzen(spalte: spalte, zeile: zeile, farbe: farbe)
            }
        }
    }
    
    /**
    Setzt die angegebene Leuchte auf die gewünschte Farbe
	- parameters:
        - spalte: die Spaltennummer der Leuchte
        - zeile: die Zeilennummer der Leuchte
        - farbe: die gewünschte Farbe
     */
    func FarbeSetzen(spalte: Int, zeile: Int, farbe: String)
    {
        leuchten[spalte][zeile].FarbeSetzen(farbe: farbe)
        farben[spalte][zeile] = farbe
    }
    
    /**
    Gibt die Farbe der angegebene Leuchte
	- parameters:
        - spalte: die Spaltennummer der Leuchte
        - zeile: die Zeilennummer der Leuchte
    - returns: die Farbe der gewünschten Leuchte
    */
    func FarbeGeben(spalte: Int, zeile: Int) -> String
    {
        return farben[spalte][zeile]
    }
    
    /**
    Meldet die Anzahl der Spalten
    - returns: Spaltenanzahl
    */
    func SpaltenanzahlGeben() -> Int
    {
        return spaltenanzahl
    }

    /**
    Meldet die Anzahl der Zeilen
    - returns: Zeilenanzahl
    */
    func ZeilenanzahlGeben() -> Int
    {
        return zeilenanzahl
    }
//#-end-editable-code
}

/**
Steuerung der Leuchten auf dem Dancefloor

- author: Klaus Reinold
- version: 1.0
 */
class DancefloorSteuerung: Figur
{
//#-editable-code
    /** Der Laufsteg */
    var d: Dancefloor
    /** Der Zufallsgenerator */
    var zufallszahlgenerator: Zufall

    /**
    Legt den Tanzboden und den Zufallsgenerator an.
    */
    override init()
    {
        zufallszahlgenerator = Zufall()
        d = Dancefloor()
        super.init()
        SichtbarkeitSetzen(sichtbar: false)
    }

    /**
    Lässt die Farben eine Spalte weiter laufen
    */
    override func AktionAusführen()
    {
        for spalte in stride(from: d.SpaltenanzahlGeben()-1, to: 0, by: -1)
        {
            for zeile in 0 ..< d.ZeilenanzahlGeben()
            {
                d.FarbeSetzen(spalte: spalte, zeile: zeile, farbe: d.FarbeGeben(spalte: spalte-1, zeile: zeile))
            }
        }
        for zeile in 0 ..< d.ZeilenanzahlGeben()
        {
            d.FarbeSetzen(spalte: 0, zeile: zeile, farbe: ZufälligeFarbeGeben())
        }
    }

    /**
    Bestimmt eine zufällige Farbe
    - returns: zufällige Farbe
     */
    func ZufälligeFarbeGeben() -> String
    {
        let zufallszahl = zufallszahlgenerator.ZufallGanz(top: 12)
        switch zufallszahl
        {
            case 0: return "weiß"
            case 1: return "rot"
            case 2: return "grün"
            case 3: return "blau"
            case 4: return "gelb"
            case 5: return "magenta"
            case 6: return "cyan"
            case 7: return "hellgelb"
            case 8: return "hellgrün"
            case 9: return "orange"
            case 10: return "braun"
            case 11: return "grau"
            default: return "schwarz"
        }
    }
//#-end-editable-code
}

//#-editable-code
/**
Steuerung der Leuchten auf dem Dancefloor

- author: Klaus Reinold
- version: 1.0
*/
class DancefloorSteuerung2: DancefloorSteuerung
{

    /**
    Erzeugt zufällige Farbwechsel
     */
   override func AktionAusführen()
    {
        for spalte in 0 ..< d.SpaltenanzahlGeben()
        {
            for zeile in 0 ..< d.ZeilenanzahlGeben()
            {
                d.FarbeSetzen(spalte: spalte, zeile: zeile, farbe: ZufälligeFarbeGeben())
            }
        }
    }
}
//#-end-editable-code

//#-editable-code
let d = DancefloorSteuerung()
//#-end-editable-code
