/*:
# **Kapitel 4.8**
## Aufgabe 11 2D-Spielwelt (Teil 7): Florian sammelt Blumen
*/

/**
Die elementare Zelle der Blumenwelt

- author: Peter Brichzin
- version: 1.0
*/
class Zelle: Rechteck
{
    /**
    Platziert eine Zelle
    */
    init (xLinksOben: Int, yLinksOben: Int, farbeNeu: String)
    {
        super.init()
        PositionSetzen(x: xLinksOben, y: yLinksOben)
        GrößeSetzen(breite: 46, höhe: 46)
        FarbeSetzen(farbe: farbeNeu)
    }
}

/**
Blume, die darauf wartet gesammelt zu werden

- author: Peter Brichzin
- version: 1.0
 */
class Blume: Figur
{
    /**
    Der Konstruktor1 erzeugt eine Blume an der Pixel-Position (225/125).
	*/
    override init ()
    {
        super.init()
        FigurteilFestlegenEllipse(x: 0, y: 0, breite: 25, höhe: 25, farbe: "gelb")
        FigurteilFestlegenEllipse(x: 0, y: -20, breite: 20, höhe: 20, farbe: "blau")
        FigurteilFestlegenEllipse(x: 20, y: -10, breite: 20, höhe: 20, farbe: "blau")
        FigurteilFestlegenEllipse(x: 20, y: 10, breite: 20, höhe: 20, farbe: "blau")
        FigurteilFestlegenEllipse(x: 0, y: 20, breite: 20, höhe: 20, farbe: "blau")
        FigurteilFestlegenEllipse(x: -20, y: -10, breite: 20, höhe: 20, farbe: "blau")
        FigurteilFestlegenEllipse(x: -20, y: 10, breite: 20, höhe: 20, farbe: "blau")
        PositionSetzen(x: 225, y: 125)
        GanzNachVornBringen()
    }
    
    /**
    Der Konstruktor2 erzeugt eine Blume in einem Spielfeld mit 10x10 Zellen.
    an der Pixel-Position (225/125).
    - parameters:
        - xNeu:  x-Position der Blume
        - yNeu:  y-Position der Blume
   */
   init (xNeu: Int, yNeu: Int)
    {
        super.init();
        FigurteilFestlegenEllipse(x: 0, y: 0, breite: 25, höhe: 25, farbe: "gelb")
        FigurteilFestlegenEllipse(x: 0, y: -20, breite: 20, höhe: 20, farbe: "blau")
        FigurteilFestlegenEllipse(x: 20, y: -10, breite: 20, höhe: 20, farbe: "blau")
        FigurteilFestlegenEllipse(x: 20, y: 10, breite: 20, höhe: 20, farbe: "blau")
        FigurteilFestlegenEllipse(x: 0, y: 20, breite: 20, höhe: 20, farbe: "blau")
        FigurteilFestlegenEllipse(x: -20, y: -10, breite: 20, höhe: 20, farbe: "blau")
        FigurteilFestlegenEllipse(x: -20, y: 10, breite: 20, höhe: 20, farbe: "blau")
        GanzNachVornBringen()
       
        if (xNeu<10) && (xNeu>=0) && (yNeu<10) && (yNeu>=0)
        {
            self.PositionSetzen(x: xNeu*50 + 25, y: yNeu*50 + 25)
        }
    }
    /**
    Die Blume verschwindet, wenn sie gepflückt wurde.
    */
    func GepflücktWerden()
    {
        if Berührt(farbe: "orange")
        {
            Entfernen()
        }
    }

    override func AktionAusführen()
    {
        GepflücktWerden()
    }
}

/**
Fliegenpilz, der darauf wartet gesammelt zu werden

- author: Peter Brichzin
- version: 1.0
 */
class Fliegenpilz: Figur
{
    /**
    Der Konstruktor erzeugt die Form.
	*/
    override init ()
    {
        super.init()
        FigurteilFestlegenRechteck(x: -10, y: 10, breite: 20, höhe: 40, farbe: "weiss")
        FigurteilFestlegenEllipse(x: -45, y: -10, breite: 90, höhe: 30, farbe: "rot")
        PositionSetzen(x: 325, y: 25)
        GanzNachVornBringen()
    }
    
    /**
     Der Konstruktor erzeugt die Form und legt die Position fest
    - parameters:
        - xNeu: die x-Koordinate
        - yNeu: die y-Koordinate
   */
   init (xNeu: Int, yNeu: Int)
    {
        super.init();
        FigurteilFestlegenRechteck(x: -10, y: 10, breite: 20, höhe: 40, farbe: "weiss")
        FigurteilFestlegenEllipse(x: -45, y: -10, breite: 90, höhe: 30, farbe: "rot")
        PositionSetzen(x: 325, y: 25)
        self.GanzNachVornBringen()
       
        if (xNeu<10) && (xNeu>=0) && (yNeu<10) && (yNeu>=0)
        {
            PositionSetzen(x: xNeu*50 + 25, y: yNeu*50 + 25)
        }
    }
    /**
    Der Fliegenpilz verschwindet, wenn er berührt wurde
    */
    func GepflücktWerden()
    {
        if Berührt(farbe: "orange")
        {
            Entfernen()
        }
    }

    /**
    Testet, ob der Pilz berührt wurde.
    */
    override func AktionAusführen()
    {
        GepflücktWerden()
    }
}

/*:
a\
Gestalte das Spiel variantenreicher, in dem z. B. zehn Blumen und acht Pilze beim Erzeugen
der Blumenwelt dort an zufälligen Positionen verteilt werden.\
b\
Überlege dir eine Erweiterung des Spiels und setze sie um. Beispielsweise könntest du
Hindernisse programmieren, die Florian den Weg versperren.*/
/**
Legt die Blumenwelt an und die nicht beweglichen Objekte.\
Die Welt besteht aus 10x10 Zellen. Damit die Objekte der Klasse Zelle gut sichtbar sind, wird
zwischen den Zellen ein Abstand von 4 Pixeln gelassen. Mit diesem Rand hat die Welt Zellen der
Größe 50x 50 Pixel.
In der Blumenwelt sind auch mehrere Blumen.

- author: Peter Brichzin
- version: 12.12.19
*/
class Blumenwelt
{
    /**
    Baut das Szenario auf.
    */
    init()
    {
        // Diesen Abschnitt ignorieren, es werden die 10x10 Zellen der Welt erzeugt und positioniert
        for zellenNummerX in 0 ... 9
        {
            for zellenNummerY in 0 ... 9
            {

                Zelle(xLinksOben: 50*zellenNummerX+2, yLinksOben: 50*zellenNummerY+2, farbeNeu: "grün")
            }
        }
        // Abschnittsende

//#-editable-code
        var nummer: Int //ein Platzhalter für eine Nummer
        nummer = 1 //Startwert 1 für die Nummer
        
        while nummer < 6
        {
            Blume(xNeu: nummer, yNeu: 3)
            nummer = nummer + 1 // die Nummer wird um eins erhöht
        }
        Blume(xNeu: 2, yNeu: 2)
        Blume(xNeu: 7, yNeu: 4)
        Blume(xNeu: 7, yNeu: 6)
        Blume(xNeu: 9, yNeu: 7)
        Blume(xNeu: 3, yNeu: 8)
        Blume(xNeu: 8, yNeu: 9)

        // Pilze werden positioniert
        for posY in 3 ..< 8
        {
            Fliegenpilz(xNeu: 6, yNeu: posY)
        }
    }
//#-end-editable-code
}

/**
Die Spielfigur der Blumentwelt.

- author: Peter Brichzin
- version: Version 1.0
 */
class Florian: Figur
{
//#-editable-code
    /** Zähler für die Schritte */
    var schritte: Int
    /** Zähler für die gesammelten Blumen */
    var gesammelteBlumen: Int
    /** Text für die Erfolgsanzeige */
    var anzeige: Text

    /**
    Legt die Form und die Startposition fest.
    */
    override init()
    {
        schritte = 0
        gesammelteBlumen = 0
        anzeige = Text()
        super.init()
        FigurteilFestlegenRechteck(x: -20, y: -15, breite: 40, höhe: 60, farbe: "orange")
        FigurteilFestlegenEllipse(x: -10, y: -50, breite: 20, höhe: 30, farbe: "orange")
        FigurteilFestlegenDreieck(x1: 0, y1: 0, x2: 0, y2: 30, x3: 18, y3: 15, farbe: "gelb")
        PositionSetzen(x: 75, y: 125)
        GanzNachVornBringen()
        anzeige.TextGrößeSetzen(größe: 20)
        anzeige.PositionSetzen(x: 520, y: 50)
    }


    /**
    Lässt Florian eine Zelle nach Osten gehen.
    */
    func NachOstenGehen()
    {
        if XPositionGeben() < 450
        {
            self.PositionSetzen(x: self.XPositionGeben()+50, y: self.YPositionGeben())
        }
    }

    /**
    Lässt Florian eine Zelle nach Westen gehen.
    */
    func NachWestenGehen()
    {
        if XPositionGeben() > 50
        {
            self.PositionSetzen(x: self.XPositionGeben()-50, y: self.YPositionGeben())
        }
    }

    /**
    Lässt Florian eine Zelle nach Süden gehen.
    */
    func NachSüdenGehen()
    {
        if YPositionGeben() < 450
        {
            self.PositionSetzen(x: self.XPositionGeben(), y: self.YPositionGeben()+50)
        }
    }

    /**
    Lässt Florian eine Zelle nach Norden gehen.
    */
    func NachNordenGehen()
    {
        if YPositionGeben() > 50
        {
            self.PositionSetzen(x: self.XPositionGeben(), y: self.YPositionGeben()-50)
        }
    }

    /**
    Dreht sich um 90 Grad nach links

    Tipp: Teste vorab (an einem Objekt der Klasse Florian)
    die Methoden Drehen, WinkelGeben, WinkelSetzen der Oberklasse
    */
    func LinksDrehen()
    {
        self.WinkelSetzen(winkel: self.WinkelGeben()+90)
    }

    /**
    Dreht sich um 90 Grad nach rechts
    */
    func RechtsDrehen()
    {
        self.WinkelSetzen(winkel: self.WinkelGeben()-90)
    }

    /**
    Florian geht einen Schritt in Blickrichtung.
    */
    func Gehen()
    {
        if WinkelGeben() == 0
        {
            NachOstenGehen()
        }
        else if WinkelGeben() == 90
        {
            NachNordenGehen()
        }
        else if WinkelGeben() == 180
        {
            NachWestenGehen()
        }
        else if WinkelGeben() == 270
        {
            NachSüdenGehen()
        }
        
        schritte = schritte + 1;
    }

    /**
    Pflückt eine Blume, falls auf der Zelle vorhanden.
     */
    func Pflücken()
    {
        if Berührt(farbe: "blau")
        {
            gesammelteBlumen = gesammelteBlumen + 1
        }
        else if Berührt(farbe: "rot")
        {
            schritte = schritte + 10
        }
    }

    /**
    Steuerung der Figur: Links-/Rechtsdrehen über Cursortasten.
	- parameters:
		- taste: die Nummer der gedrückten Taste
    */
    override func SonderTasteGedrückt(taste: Int)
    {
        if taste == 124
        {
            RechtsDrehen()
        }
        else
        {
            if taste == 123
            {
                LinksDrehen()
            }
        }
    }
    
    /**
    Ständige Bewegung, außer Florian ist an der Grenze seiner Welt.
    */
    override func AktionAusführen()
    {
        Gehen()
        Pflücken()
        anzeige.TextSetzen(text: "Schritte \(schritte) Blumen \(gesammelteBlumen)")
        if(gesammelteBlumen == 10)
        {
            Ereignisbehandlung().Anhalten()
        }
    }
//#-end-editable-code
}
//#-editable-code



//#-end-editable-code

//#-editable-code
Blumenwelt()
Florian()
//#-end-editable-code
