import Foundation
/*:
# **Kapitel 4.8**
## Aufgabe 12 Jäger und Beute - Maussteuerung
*/
/*:
Ein Beuteobjekt (roter Kreis) bewegt sich zufallsgesteuert über das Spielfeld. Der Jäger (blaues Quadrat
mit gelbem Pfeil) muss das Beuteobjekt berühren. Seine Richtung kann durch Mausklick gesteuert werden:
Jeder Mausklick dreht den Jäger genau in Richtung des Klicks.\
a\
Die Klasse BEUTE im Projekt JägerUndBeuteStart erbt von FIGUR. Ergänze in der Klasse BEUTE den
Konstruktor so, dass die Beute das von dir gewünschte Aussehen bekommt. Beim Berühren wird
die Methode Umfärben aufgerufen. Ergänze die Methode, so dass sich das Aussehen der Beute
passend verändert.\
b\
Ergänze den Konstruktor der Klasse JÄGER so, dass der Jäger das von dir gewünschte Aussehen bekommt.\
c\
Ergänze in der Klasse JÄGER einen Zufallsgenerator (du kannst in der Klasse BEUTE nachsehen) und
sorge dafür, dass der Jäger mit zufälliger Startposition und zufälligem Winkel beginnt.\
d\
Analysiere in der Klasse JÄGER, wie ein Mausklick verarbeitet wird. Beschreibe dabei insbesondere
die Aufgabe der Methode *RichtungGeben*, ohne dabei auf deren Implementierung einzugehen.
Gib die Bedeutung der einzelnen Teile des Kopfs dieser Methode an und nenne die Anweisung,
mit der das Ergebnis zurückgegeben wird.\
e\
Ergänze in der Klasse JÄGER ein Attribut um mitzuzählen, wie oft der Jäger die Beute berührt hat.\
f\
Ergänze die Klasse BEUTE so, dass die Beute an einen neuen, zufällig bestimmten Ort wechselt,
wenn sie berührt wurde.\
g\
Ergänze die Klasse BEUTE so, dass das Umfärben der Beute nach z. B. 10 Taktimpulsen
rückgängig gemacht wird.\
h\
Für Schnelle: Recherchiere im Internet die Bedeutung der Funktion Arcustangens. Gib mit Hilfe
dieser Beschreibung an, wie die Methode *RichtungGeben* ihre Aufgabe erfüllt.*/
/**
Die Beute wandert zufällig über das Spielfeld.
Sie wechselt ihre Richtung immer wahrscheinlicher,
Sje länger sie gerade aus läuft.

Als Darstellungssymbol hat sie einen Kreis

- author: Albert Wiedemann
- version: 1.0
 */
class Beute: Figur
{
//#-editable-code
    /** Zähler für die Bewegungsschritte geradeaus. */
    var zähler: Int
    /** Der Zufallsgenerator. */
    var zufall: Zufall
    /** Breite des Spielfeldes. */
    var breite: Int
    /** Höhe des Spielfeldes. */
    var höhe: Int
    
    /**
    Legt das Anzeigesymbol an und wählt eine zufällige Startposition.
	- parameters:
        - breite: Breite des Spielfelds
        - höhe: Höhe des Spielfelds
     */
    init (breite: Int, höhe: Int)
    {
        zähler = 0
        zufall = Zufall()
        self.breite = breite
        self.höhe = höhe
        super.init()
        PositionSetzen(x: zufall.ZufallGanz(top: breite), y: zufall.ZufallGanz(top: höhe))
        WinkelSetzen(winkel: zufall.ZufallGanz(top: 360))
        // Eigenes Aussehen der Beute einbauen
  
  
    }
    
    /**
    Bewegt die Beute um 10 Einheiten in der eingestellten Richtung.
    Wir der Rand erreicht, wird die Richtung nach dem Reflexionsgesetzt
    gedreht. Außerdem wird sie spätestens nach 100 Schritten
    zufällig neu bestimmt; je länger die Geradesausbewegung,
    desto wahrscheinlicher ist die zufällige Änderung.
    */
    override func AktionAusführen()
    {
        if (zufall.ZufallGanz(top: 100) < zähler)
        {
            WinkelSetzen(winkel: zufall.ZufallGanz(top: 360))
            zähler = 0
        }
        Gehen (länge: 10)
        zähler = zähler + 1
        if (XPositionGeben() > breite) && (0 <= WinkelGeben()) && (WinkelGeben() < 90)
        {
            WinkelSetzen(winkel: 180 - WinkelGeben())
        }
        else if (XPositionGeben() > breite) && (270 < WinkelGeben()) && (WinkelGeben() < 360)
        {
            WinkelSetzen(winkel: 540 - WinkelGeben())
        }
        else if  (XPositionGeben() < 0) && (90 < WinkelGeben()) && (WinkelGeben() <= 180)
        {
            WinkelSetzen(winkel: 180 - WinkelGeben())
        }
        else if (XPositionGeben() < 0) && (180 < WinkelGeben()) && (WinkelGeben() < 270)
        {
            WinkelSetzen(winkel: 540 - WinkelGeben())
        }
        if (YPositionGeben() < 0) && ((0 < WinkelGeben()) || (WinkelGeben() < 180))
        {
            WinkelSetzen(winkel: 360 - WinkelGeben())
        }
        else if (YPositionGeben() > höhe) && (180 < WinkelGeben()) && (WinkelGeben() < 360)
        {
            WinkelSetzen(winkel: 360 - WinkelGeben())
        }
        if (Berührt())
        {
            Umfärben()
        }
    }

    /**
    Färbt die erreichte Beute um.
    */
    func Umfärben()
    {
        // Eigene Form der Beute nach der Berührung einbauen.


    }
//#-end-editable-code
    
    /**
	Dummy zur unterdrückung der Ausgabe
     */
    override func MausGeklickt(x: Int, y: Int, anzahl: Int)
    {
        //nix
    }
}

/**
Der Verfolger wird durch die Maus gesteuert.

- author: Albert.Wiedemann
- version: 1.0
 */
class Jäger: Figur
{
//#-editable-code
    /** Breite des Spielfeldes. */
    var breite: Int
    /** Höhe des Spielfeldes. */
    var höhe: Int

    /**
    Legt die Anzeigesymbole an und positioniert den Verfolger
    in der Mitte des Feldes.
	- parameters:
        - breite: Breite des Spielfelds
        - höhe: Höhe des Spielfelds
     */
    init(breite: Int, höhe: Int)
    {
        self.breite = breite
        self.höhe = höhe
        super.init()
        PositionSetzen(x: breite / 2, y: höhe / 2)
        WinkelSetzen(winkel: 0)
        // Eigenes Aussehen des Jägers einbauen
  
  
    }
    
    /**
    Bewegt den Verfolger um 10 Einheiten in der eingestellten Richtung.
    Wird der Rand erreicht, wird die Bewegung gestoppt.
     */
    override func AktionAusführen()
    {
        let xalt = XPositionGeben()
        let yalt = YPositionGeben()
        Gehen(länge: 10)
        if (XPositionGeben() < 0) && (XPositionGeben() < xalt) || (XPositionGeben() > breite) && (XPositionGeben() > xalt) ||
           (YPositionGeben() < 0) && (YPositionGeben() < yalt) || (YPositionGeben() > höhe) && (YPositionGeben() > yalt)
        {
            PositionSetzen(x: xalt, y: yalt)
        }
    }
    
    /**
    Die eigentliche Aktionsmethode für einen Mausklick.
    
    Muss bei Bedarf von einer Unterklasse überschrieben werden.
	- parameters:
        - x: x-Position des Mausklicks
        - y: y-Position des Mausklicks
        - anzah:l Anzahl der aufeinanderfolgenden Mausklicks
     */
    override func MausGeklickt (x: Int, y: Int, anzahl: Int)
    {
        WinkelSetzen(winkel: RichtungGeben(xMaus: x, yMaus: y))
    }
    
    /**
    Wird bei Mausklick aufgerufen, um die Bewegungsrichtung des Verfolgers zu ermitteln.
	- parameters:
        - xMaus: x-Koordinate der Maus
        - yMaus: y-Koordinate der Maus
	- returns: Richtungswinkel zum Klickpunkt
     */
    func RichtungGeben (xMaus: Int, yMaus: Int) -> Int
    {
        let dx = xMaus - XPositionGeben()
        let dy = yMaus - YPositionGeben()
        var richtung = 0;
        if dx == 0
        {
            if dy > 0
            {
                richtung = 270
            }
            else if dy < 0
            {
                richtung = 90
            }
        }
        else if dx > 0
        {
            richtung = -Int(Double.rounded(atan(Double(dy) / Double(dx)) * 180.0 / Double.pi)())
        }
        else
        {
            richtung = 180 - Int(Double.rounded(atan(Double(dy) / Double(dx)) * 180.0 / Double.pi)())
        }
        return richtung;
    }
//#-end-editable-code
}

/**
Steuert das Verfolgungsspiel.

- author: Albert Wiedemann
- version: 1.0
 */
class Verfolgung: Ereignisbehandlung
{
    /**
    Legt die Objekte an.
    */
    override init ()
    {
        super.init()
        Beute(breite: 600, höhe: 400)
        Jäger(breite: 600, höhe: 400)
        TaktdauerSetzen(dauer: 100)
    }
    
    /**
	Dummy zur unterdrückung der Ausgabe
     */
    override func MausGeklickt(x: Int, y: Int, anzahl: Int)
    {
        //nix
    }
    
    /**
	Dummy zur unterdrückung der Ausgabe
     */
    override func TaktImpulsAusführen()
    {
        //nix
    }
}

//#-editable-code
let tropfen = Verfolgung()
//#-end-editable-code
        
